<template>
    <div class="edit-popup">
        <popup ref="popupRef" :title="popupTitle" :async="true" width="80%" @confirm="handleSubmit" @close="handleClose">
            <el-form ref="formRef" :model="formData" label-width="120px" :rules="formRules">
                <el-row>
                    <el-col :span="8">
                        <el-form-item label="项目类型" prop="project_type_id" @click="showDialog = true"
                            :rules="[{ required: true, message: '不可为空', trigger: 'change' }]">
                            <el-select class="w-[280px]" v-model="formData.project_type_id" clearable placeholder="请选择项目类型">
                                <el-option v-for="(item, index) in list" :key="index" :label="item.name"
                                    :value="parseInt(item.id)" />
                            </el-select>
                        </el-form-item> </el-col>
                    <el-col :span="8">
                        <el-form-item label="最低利润率(%)" prop="profit_rate"
                            :rules="[{ required: true, message: '不可为空', trigger: 'blur' }]">
                            <el-input v-model="formData.profit_rate" type="number" clearable placeholder="请输入最低利润率(%)" />
                        </el-form-item> </el-col>
                    <el-col :span="8">
                        <el-form-item label="备注" prop="remark">
                            <el-input v-model="formData.remark" clearable placeholder="请输入备注" />
                        </el-form-item> </el-col>






                </el-row>

            </el-form>
        </popup>


    </div>
</template>

<script lang="ts" setup name="procurementContractEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiProjectprofitAdd, apiProjectprofitEdit, apiProjectprofitDetail } from '@/api/project_profit_set'
import { getAllProjectTypes } from '@/api/projecttype'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')
const list = ref([])
const list1 = ref([{
    name: '是',
    id: 1
},
{
    name: '否',
    id: 2
}])
const showDialog = ref(false)
const project_name = ref('')
const project_code = ref('')
// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑项目利润设置' : '新增项目利润设置'
})

// 表单数据
const formData = reactive({
    id: '',
    project_type_id: '',
    profit_rate: '',
    remark: '',


})


// 表单验证
const formRules = reactive<any>({

})
//获取项目类型
const getlist = () => {
    getAllProjectTypes().then((res) => {

        list.value = res
    })
}


// 获取详情
const setFormData = async (data: Record<any, any>) => {


    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }


}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiProjectprofitDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {

    await formRef.value?.validate()
    const data = { ...formData, }
    mode.value == 'edit'
        ? await apiProjectprofitEdit(data)
        : await apiProjectprofitAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}


getlist()

defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
